//
//  ANVideoTutorialsController.h
//  AvisNocturnaMacCore
//
//  Created by Mendel Kucharzeck on 28.07.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

@protocol ANVideoTutorialsControllerDelegate
- (void) videoTutorialsHaveBeenUpdated;
- (void) videoTutorialsUpdateFailed;
@end

@interface ANVideoTutorialsController : NSObject
{
    NSArray *availableTutorialDictionaries;
    
    NSMutableArray *delegates;
    
    //Query Connection
    NSURLConnection *queryConnection;
    NSMutableData *queryConnectionData;
}

+ (ANVideoTutorialsController*) sharedTutorialsController;
- (void) startQueryTutorialsForApp:(NSString*)app;

- (void) addDelegate:(id <ANVideoTutorialsControllerDelegate>)d;
- (void) removeDelegate:(id)d;

- (BOOL) isUpToDate;

- (NSMenu*) tutorialsMenuIncludingTopLevelItem:(BOOL)topLevelItem;

@end
