//
//  LCFilterPreset.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 14.01.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

@class LCBaseObject;

@interface LCFilterPreset : NSObject <NSCoding>
{
    NSMutableArray *filters;
    
    NSString *fileIdentifier;
    NSString *categoryName;
    NSString *localizedCategoryName;
    BOOL isUserPreset;
}

@property (retain) NSMutableArray *filters;

@property (retain) NSString *fileIdentifier;
@property (retain) NSString *categoryName;
@property (retain) NSString *localizedCategoryName;
@property (assign) BOOL isUserPreset;

- (void) applyToObject:(LCBaseObject*)object;

- (CGImageRef) lettersThumbnailWithContentsScale:(float)contentsScale;
- (CGImageRef) circleThumbnailWithContentsScale:(float)contentsScale;
- (CGImageRef) rectThumbnailWithContentsScale:(float)contentsScale;
- (CGImageRef) sampleImageThumbnailWithContentsScale:(float)contentsScale;

@end
