//
//  LCObjectsTimeLineManagerDelegateProtocol.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 05.08.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

@class LCObjectsTimelineManager;
@class LCObjectsTimelineProperty;
@class LCObjectsTimelinePropertyChange;

@protocol LCObjectsTimelineManagerDelegateProtocol <NSObject>

- (void) timeLineManager:(LCObjectsTimelineManager*)timelineManager didChangeCurrentTimeTo:(float)currentTime;
- (void) timeLineManager:(LCObjectsTimelineManager*)timelineManager didChangeProperties:(NSArray*)properties;
- (void) timeLineManager:(LCObjectsTimelineManager*)timelineManager didChangePropertyChanges:(NSArray*)changes;
- (void) timeLineManager:(LCObjectsTimelineManager*)timelineManager didChangeTimeOfPropertyChanges:(NSArray*)changes;

- (void) timeLineManagerDidStartPlaying:(LCObjectsTimelineManager*)timelineManager;
- (void) timeLineManagerDidStopPlaying:(LCObjectsTimelineManager*)timelineManager;

@end
