//
//  LCObjectsTimelinePropertyChange.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 19.08.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

@class LCObjectsTimelineProperty;

enum _LCObjectsTimelinePropertyChange_Interpolation
{
    LCObjectsTimelinePropertyChange_Interpolation_Linear = 0,
    LCObjectsTimelinePropertyChange_Interpolation_EaseIn,
    LCObjectsTimelinePropertyChange_Interpolation_EaseOut,
    LCObjectsTimelinePropertyChange_Interpolation_EaseInEaseOut
    
}typedef LCObjectsTimelinePropertyChange_Interpolation;

enum _LCObjectsTimelinePropertyChange_ValueInterpolation
{
    LCObjectsTimelinePropertyChange_ValueInterpolation_Linear = 0,
    LCObjectsTimelinePropertyChange_ValueInterpolation_Spline
    
}typedef LCObjectsTimelinePropertyChange_ValueInterpolation;

@interface LCObjectsTimelinePropertyChange : NSObject <NSCopying>
{
    LCObjectsTimelineProperty *timelineProperty;
    
    float time;
    id value;
    LCObjectsTimelinePropertyChange_Interpolation interpolation;
    
    LCObjectsTimelinePropertyChange_ValueInterpolation valueInterpolation;
    float valueInterpolationTension;
}

- (id) initWithTimelineProperty:(LCObjectsTimelineProperty*)t;

@property (assign) LCObjectsTimelineProperty *timelineProperty;

@property (assign) float time;
@property (retain) id value;
@property (assign) LCObjectsTimelinePropertyChange_Interpolation interpolation;
@property (assign) LCObjectsTimelinePropertyChange_ValueInterpolation valueInterpolation;
@property (assign) float valueInterpolationTension;

@end
