//
//  LCShadedMaterial.h
//  LogoistCore
//
//  Created by Mendel Kucharzeck on 11.01.12.
//  Copyright (c) 2012 AvisNocturna Software. All rights reserved.
//

#import "LCTimelineAnimateableObject.h"

@class LCShadedMaterialLight;

extern NSString *LCShadedMaterialChangedNotificationName;

@interface LCShadedMaterial : LCTimelineAnimateableObject <NSCopying>
{
    NSMutableArray *lights;

    id backgroundColor;
    
    LCTimelineAnimateableObject *superObjectForChangeManager;
    
    //Cache
    CGImageRef cachedImage;
    CGSize cachedImageSize;
    float cachedImageNormalRotation;
}

- (void) addLight:(LCShadedMaterialLight*)light;
- (void) removeLight:(LCShadedMaterialLight*)light;
@property (copy) NSArray *lights;

@property (retain) id backgroundColor;

- (void) postShadedMaterialChangedNotification;

@property (assign) LCTimelineAnimateableObject *superObjectForChangeManager;

@end
